package models

import (
	"log"

	"github.com/sujit-baniya/fiber-boilerplate/app"
	"gorm.io/gorm"
)

type Servidor struct {
	gorm.Model
	Nombre         string       `json:"nombre" gorm:"column:nombre"`
	IpServidor     string       `json:"ip_servidor" gorm:"column:ip_servidor"`
	So             string       `json:"so" gorm:"column:so"`
	Vencimiento    string       `json:"vencimiento" gorm:"column:vencimiento"`
	Ram            string       `json:"ram" gorm:"column:ram"`
	Nucleos        string       `json:"nucleos" gorm:"column:nucleos"`
	Disco          string       `json:"disco" gorm:"column:disco"`
	UltimoPing     string       `json:"ultimo_ping" gorm:"column:ultimo_ping"`
	ProvServidorID uint         `json:"prov_servidor_id" gorm:"column:prov_servidor_id;foreignKey:ProvServidorID"`
	ProvServidor   ProvServidor `json:"prov_servidor" gorm:"foreignKey:ProvServidorID"`
	TipoServidorID uint         `json:"tipo_servidor_id" gorm:"column:tipo_servidor_id;foreignKey:TipoServidorID"`
	TipoServidor   TipoServidor `json:"tipo_servidor" gorm:"foreignKey:TipoServidorID"`
}

func (Servidor) TableName() string {
	return "servidor"
}

func GetAllServidores(limit, offset int, search string) ([]Servidor, int64, error) {
	var items []Servidor
	var total int64
	db := app.Http.Database.DB.Model(&Servidor{})

	if search != "" {
		db = db.Where("nombre LIKE ? OR ip_servidor LIKE ?", "%"+search+"%", "%"+search+"%")
	}

	db = db.Preload("ProvServidor").Preload("TipoServidor")

	if err := db.Count(&total).Error; err != nil {
		log.Printf("Error counting servidores: %v", err)
		return nil, 0, err
	}

	if err := db.Order("created_at DESC").Limit(limit).Offset(offset).Find(&items).Error; err != nil {
		log.Printf("Error retrieving servidores: %v", err)
		return nil, 0, err
	}

	return items, total, nil
}

func GetAllServidoresSelect() ([]Servidor, error) {
	var items []Servidor
	db := app.Http.Database.DB.Model(&Servidor{})

	if err := db.Order("created_at DESC").Find(&items).Error; err != nil {
		log.Printf("Error retrieving servidores: %v", err)
		return nil, err
	}
	return items, nil

}

func CreateServidor(servidor Servidor) error {
	if err := app.Http.Database.DB.Create(&servidor).Error; err != nil {
		return err
	}
	return nil
}

func UpdateServidor(servidor Servidor) error {
	if err := app.Http.Database.DB.Model(&servidor).Updates(servidor).Error; err != nil {
		return err
	}
	return nil
}

func DeleteServidor(servidor Servidor) error {
	if err := app.Http.Database.DB.Delete(&servidor).Error; err != nil {
		return err
	}
	return nil
}
